package SOFA.demos.protodemo;

public class LoggingWorkerBodyImpl implements WorkInterface {
  SOFA.Component.DCUP.DCUPComponentManagerImpl cm;

  LogInterface  LogRequirement;
  
  public LoggingWorkerBodyImpl (SOFA.Component.DCUP.DCUPComponentManagerImpl _cm)  {
    cm = _cm;
  }

  private void setRequirement() throws SOFA.Component.NamingException {
    LogRequirement = (LogInterface) cm.getRequirement("Log");
  }

  public void init() {
    try {
      setRequirement();
    } catch (SOFA.Component.NamingException e) {
      throw new SOFA.SOFAnode.Run.SOFARuntimeException("Bad requirements", e);
    }
  }
  
  public void start() {
    System.out.println("LoggingWorkerBody: start");
    LogRequirement.log("I am starting.");
  }

  public void finish() {
    System.out.println("LoggingWorkerBody: finish");
    LogRequirement.log("I am finishing.");
  }

  public void doit() {
    System.out.println("LoggingWorkerBody: doit");
    LogRequirement.log("I am doing it.");
  }
}
